#ifndef BVP_HH
#define BVP_HH

#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>

/*

 

 */

class BVP {
public:
  typedef double value_type ;

private:
  std::vector<value_type> x, y ;

public:

  BVP( ) { std::cout << "call constuctor BVP class\n" ; }

  virtual ~BVP( ) { std::cout << "call descructor BVP class\n" ; }

  virtual value_type p( value_type x ) const = 0 ;
  virtual value_type q( value_type x ) const = 0 ;
  virtual value_type r( value_type x ) const = 0 ;

  void
  solve( value_type a, value_type Ya,
         value_type b, value_type Yb,
         int        N ) ;

  std::vector<value_type> const & get_x() const { return x ; }
  std::vector<value_type> const & get_y() const { return y ; }

} ;

#endif

